##############################
### ROZDZIAL 2 ###############
##############################
### DFM ######################
##############################
### (C) Kamil uczkowski #####
##############################

#Zaladowanie danych

# Podaj sciezke do przestrzeni roboczej
setwd("C:/zastosowania_ekonometrii_www/02/")
dane <- read.csv("rozdzial_2.csv", header = TRUE, dec = ",", sep = ";")
data <- as.Date(dane[, 1])
colnames(dane)[1] <- "data"
attach(dane)

#Analiza glownych skladowych
pca <- prcomp(dane[, c(-1, -81)], retx = TRUE)
summary(pca)
screeplot(pca, type = "lines", npcs = 8, main = "Wykres osypiska", col = "red", lwd = 2)

#Wartosci glownych skladowych dla wszystkich jednostek czasu

PC1 <- pca$x[, 1]
PC2 <- pca$x[, 2]
PC3 <- pca$x[, 3]
PC4 <- pca$x[, 4]
PC5 <- pca$x[, 5]

#Tworzenie zmiennych do DFM
PC1_lag1 <- PC1[2:106]
PC2_lag1 <- PC2[2:106]
PC3_lag1 <- PC3[2:106]
PC4_lag1 <- PC4[2:106]
PC5_lag1 <- PC5[2:106]
PC1_lag2 <- PC1[1:105]
PC2_lag2 <- PC2[1:105]
PC3_lag2 <- PC3[1:105]
PC4_lag2 <- PC4[1:105]
PC5_lag2 <- PC5[1:105]
CPI_emp_lag <- CPI_emp[2:106]

#Estymacja DFM
model <- lm(CPI_emp[3:107] ~ 0 + CPI_emp_lag + PC1_lag1 + PC1_lag2 + PC2_lag1 + PC2_lag2 + 
                                 PC3_lag1 + PC3_lag2 + PC4_lag1 + PC4_lag2 + PC5_lag1 + PC5_lag2)
summary(model)
model <- lm(CPI_emp[3:107] ~ 0 + CPI_emp_lag + PC2_lag2 + PC3_lag1 + PC4_lag1 + PC4_lag2 + PC5_lag1) 
summary(model)

#Jednoookresowa prognoza
CPI_emp_lag <- CPI_emp[107]
PC2_lag2 <- PC2[106]
PC3_lag1 <- PC3[107]
PC4_lag1 <- PC4[107]
PC4_lag2 <- PC4[106]
PC5_lag1 <- PC5[107]

install.packages("forecast")
library(forecast)
dane_prognoza <- data.frame(CPI_emp_lag, PC2_lag2, PC3_lag1, PC4_lag1, PC4_lag2, PC5_lag1)
forecast.lm(model, dane_prognoza, h = 1)


